NBUT 1116 Flandre's Passageway (LIS变形)

题意:给一个有n*m格子的矩形,设每格边长100,要从(1,1)走到(n,m)需要耗(n+m)*100,但是其中有一些格子是可以直接穿过的,也就是走对角线,是100*根号2长,给出k个可以穿过的格子,要求最短路径是多少?

思路:研究一下知道当选择了某个可穿过的格子(x,y),那么对于任意格子(>x,y)和(x,>y)都是不能再选的,因为这样会更长,也就是说同一行最多只能选一个格子穿过。一开始想到的是在一个拓扑序列中求最小路径的权之和,这个模型倒是没错,但是怎么建立一个这样的图就麻烦了。再想到用DP来穷举每个格子,复杂度O(N*M),上限有100亿,会超时,而且当k=1,n=m=100000时,复杂度还要n*m。看到别人提出LIS最长递增子序列。先按x坐标排个序,对于每个可穿的格子,判断若要穿过此格子,其前面还能穿过几个。按照O(N^2)的方法做的,代码较短。

 1 #include<bits/stdc++.h>
 2 using namespace std;
 3 const int N=2010;
 4 int n, m, k, dp[N];
 5 struct node
 6 {
 7     int x,y;
 8 }a[N];
 9 int cmp(node a, node b)
10 {
11     return a.x < b.x ? 1 :0;
12 }
13 bool cpr(node *a, node *b)//这里与LIS不同在:这是二维的
14 {
15     if(a->x < b->x && a->y < b->y )
16         return true;
17     else
18         return false;
19 }
20 int cal()
21 {
22     memset(dp,0,sizeof(dp));
23     int big=0;
24     for(int i=1; i<=k; i++)
25     {
26         int j=i, tmp=0;
27         while(--j)
28             if( dp[j]>tmp && cpr(&a[j],&a[i]))    tmp=dp[j];
29         dp[i]=tmp+1;
30         if(dp[i]>big)   big=dp[i];
31     }
32     return big;
33 }
34 int main()
35 {
36     //freopen("e://input.txt","r",stdin);
37     while(cin>>n>>m)
38     {
39         cin>>k;
40         a[0].x=a[0].y=-1;
41         for(int i=1; i<=k; i++)
42             scanf("%d%d",&a[i].x,&a[i].y);  //x是n那边的
43         sort(a+1,a+k+1,cmp);
44         int cnt=cal();
45         double ans=(n+m-2*cnt)*100+sqrt(2.0)*100*cnt;
46         printf("%d\n",(int)(ans+0.5));
47     }
48     return 0;
49 }

AC代码

NBUT 1116 Flandre's Passageway (LIS变形)

时间: 2024-10-09 21:21:08

NBUT 1116 Flandre's Passageway (LIS变形)的相关文章

hdu 1087(LIS变形)

Super Jumping! Jumping! Jumping! Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)Total Submission(s): 31458    Accepted Submission(s): 14128 Problem Description Nowadays, a kind of chess game called “Super Jumping!

HDU1160_FatMouse&#39;s Speed【LIS变形】

FatMouse's Speed Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 9624    Accepted Submission(s): 4284 Special Judge Problem Description FatMouse believes that the fatter a mouse is, the faster

挖地雷(LIS变形)

挖地雷(LIS变形)  AC_Code: 1 #include <iostream> 2 #include <cstdio> 3 #include <cmath> 4 #include <cstring> 5 #include <cstdlib> 6 #include <string> 7 #include <vector> 8 #include <queue> 9 #include <vector>

登山(LIS变形)

登山(LIS变形) 注意读题:不连续两个相同海拔,所以要么严格递增,要么严格递减 AC_Code 1 #include <iostream> 2 #include <cstdio> 3 #include <cstring> 4 #include <string> 5 #include <cmath> 6 #include <cstdlib> 7 #include <queue> 8 #include <vector&

hust校赛 f题 The tree of hust(lis 变形)

题目大意是给出一段数字序列,可以忽略一次一段连续的序列,求忽略后的最长连续上升子序列 思路是dp,用end数组记录以当前元素作为结尾的最长连续上升序列的元素个数,那么不难得到状态转移方程为 dp(i) = max(dp(i - 1),  max( end[k] ) ) + 1 代码如下: #include<cstdio> #include<cstring> #include<cmath> #include<cstdlib> #include<iostr

hdu5773--The All-purpose Zero(LIS变形)

题意:给一个非负整数的数列,其中0可以变成任意整数,包括负数,求最长上升子序列的长度. 题解:LIS是最简单的DP了,但是变形之后T^T真的没想到.数据范围是10^5,只能O(nlogn)的做法,所以一直在想0要插到哪里. 题解是先求不包括0的数列的LIS,再将0插入其中,由于直接插入不会保证递增,对其他数字进行处理,就是减去这个数字前面0的个数. 这个可以理解成优先选择0,所以一个数如果要被选中,就要大于中间这个0插入后变成的数,当然不用担心这样不对,因为如果一个数因为处理后不能选进,其实0也

UVa 1471 (LIS变形) Defense Lines

题意: 给出一个序列,删掉它的一个连续子序列(该子序列可以为空),使得剩下的序列有最长的连续严格递增子序列. 分析: 这个可以看作lrj的<训练指南>P62中讲到的LIS的O(nlogn)的优化变形过来的问题. 预处理: Li是第i个元素Ai向左延伸的最大长度,即[i, i + Li - 1]是一个递增区间 同样地,Ri是第i个元素向右延伸的最大长度. 我们,可以枚举i, j(j<i 且 Aj < Ai),这样就可以把Aj和Ai“拼接”起来,所得到的最长连续递增子列的长度就是Lj

POJ 1836-Alignment(DP/LIS变形)

Alignment Time Limit: 1000MS   Memory Limit: 30000K Total Submissions: 13465   Accepted: 4336 Description In the army, a platoon is composed by n soldiers. During the morning inspection, the soldiers are aligned in a straight line in front of the cap

BZOJ 1046 上升序列(LIS变形)

要保证长度为L的序列下标字典序最小,当然要尽量选前面的数. 如何判断前面的数是否满足条件?,只需要知道这个数开头的递增序列的最长长度是多少,如果不小于L,那么必然可以加入这个数.还需判断一下它是否大于前面的那个数就行了. LIS用nlogn. # include <cstdio> # include <cstring> # include <cstdlib> # include <iostream> # include <vector> # in